Add "app name" concept, and rename APP → TYPE
continuous-integration/drone/pr Build is failing Details

Ref #47
This commit is contained in:
3wc 2020-12-30 21:24:06 +02:00
parent 8384af8b95
commit 6761574d74
2 changed files with 123 additions and 108 deletions

View File

@ -6,6 +6,7 @@
- `check` is run on `deploy` now and configurable ([77ba5652b2fe15820f5edfa0f642636f7b8eae7e](https://git.autonomic.zone/coop-cloud/abra/commit/77ba5652b2fe15820f5edfa0f642636f7b8eae7e))
- App configurations are always updated now ([#42](https://git.autonomic.zone/coop-cloud/abra/issues/42))
- We use docker format `.env` files (no "export" syntax) from now now ([#55](https://git.autonomic.zone/coop-cloud/abra/pulls/55))
- Rename `<domain>` option to `<app>` and `APP` variable to `TYPE`, see [#47](https://git.autonomic.zone/coop-cloud/abra/pulls/55)
# abra 0.4.1 (2020-12-24)
@ -15,7 +16,7 @@
# abra 0.4.0 (2020-12-24)
- New command-line interface based on docopt
- ~/.abra directory instead of expecting local .env files
- `~/.abra` directory instead of expecting local `.env` files
- Integration tests & code coverage
# abra 0.3.1 (2020-09-27)

228
abra
View File

@ -11,7 +11,7 @@ DOC="
The cooperative cloud utility belt 🎩🐇
Usage:
abra [options] app new [--server=<server>] [--domain=<domain>] [--pass] [--auto] <type>
abra [options] app new [--server=<server>] [--domain=<domain>] [--app-name=<app_name>] [--pass] [--auto] <type>
abra [options] app (list|ls) [--status] [--server=<server>]
abra [options] app <app> deploy [--skip-check]
abra [options] app <app> undeploy
@ -142,82 +142,85 @@ eval "var_$1+=($value)"; else eval "var_$1=$value"; fi; return 0; fi; done
return 1; }; stdout() { printf -- "cat <<'EOM'\n%s\nEOM\n" "$1"; }; stderr() {
printf -- "cat <<'EOM' >&2\n%s\nEOM\n" "$1"; }; error() {
[[ -n $1 ]] && stderr "$1"; stderr "$usage"; _return 1; }; _return() {
printf -- "exit %d\n" "$1"; exit "$1"; }; set -e; trimmed_doc=${DOC:1:1424}
usage=${DOC:40:1116}; digest=479f2
shorts=(-e -h -s -v '' '' '' '' '' '' '' '' '' '')
longs=(--env --help --stack --version --server --domain --pass --auto --status --skip-check --force --no-tty --user --all)
argcounts=(1 0 1 0 1 1 0 0 0 0 0 0 1 0); node_0(){ value __env 0; }; node_1(){
switch __help 1; }; node_2(){ value __stack 2; }; node_3(){ switch __version 3
}; node_4(){ value __server 4; }; node_5(){ value __domain 5; }; node_6(){
switch __pass 6; }; node_7(){ switch __auto 7; }; node_8(){ switch __status 8; }
node_9(){ switch __skip_check 9; }; node_10(){ switch __force 10; }; node_11(){
switch __no_tty 11; }; node_12(){ value __user 12; }; node_13(){ switch __all 13
}; node_14(){ value _type_ a; }; node_15(){ value _app_ a; }; node_16(){
value _service_ a; }; node_17(){ value _src_ a; }; node_18(){ value _dst_ a; }
node_19(){ value _args_ a true; }; node_20(){ value _secret_ a; }; node_21(){
value _version_ a; }; node_22(){ value _cmd_ a; }; node_23(){ value _data_ a; }
node_24(){ value _command_ a; }; node_25(){ value _host_ a; }; node_26(){
value _user_ a; }; node_27(){ value _port_ a; }; node_28(){ _command app; }
node_29(){ _command new; }; node_30(){ _command list; }; node_31(){ _command ls
}; node_32(){ _command deploy; }; node_33(){ _command undeploy; }; node_34(){
_command config; }; node_35(){ _command delete; }; node_36(){ _command rm; }
node_37(){ _command logs; }; node_38(){ _command cp; }; node_39(){
_command check; }; node_40(){ _command ps; }; node_41(){ _command run; }
node_42(){ _command secret; }; node_43(){ _command auto; }; node_44(){
_command generate; }; node_45(){ _command insert; }; node_46(){ _command server
}; node_47(){ _command add; }; node_48(){ _command init; }; node_49(){
_command apps; }; node_50(){ _command upgrade; }; node_51(){ optional 0 1 2 3; }
node_52(){ optional 51; }; node_53(){ optional 4; }; node_54(){ optional 5; }
node_55(){ optional 6; }; node_56(){ optional 7; }; node_57(){
required 52 28 29 53 54 55 56 14; }; node_58(){ either 30 31; }; node_59(){
required 58; }; node_60(){ optional 8; }; node_61(){ required 52 28 59 60 53; }
node_62(){ optional 9; }; node_63(){ required 52 28 15 32 62; }; node_64(){
required 52 28 15 33; }; node_65(){ required 52 28 15 34; }; node_66(){
either 35 36; }; node_67(){ required 66; }; node_68(){ optional 10; }
node_69(){ required 52 28 15 67 68; }; node_70(){ optional 16; }; node_71(){
required 52 28 15 37 70; }; node_72(){ required 52 28 15 38 17 18; }; node_73(){
required 52 28 15 39; }; node_74(){ required 52 28 15 40; }; node_75(){
optional 11; }; node_76(){ optional 12; }; node_77(){ oneormore 19; }
node_78(){ required 52 28 15 41 75 76 16 77; }; node_79(){
required 52 28 15 42 43 55; }; node_80(){ optional 22; }; node_81(){
required 52 28 15 42 44 20 21 80 55; }; node_82(){
required 52 28 15 42 45 20 21 23 55; }; node_83(){ either 20 13; }; node_84(){
required 83; }; node_85(){ required 52 28 15 42 67 84 55 68; }; node_86(){
optional 77; }; node_87(){ required 52 28 15 24 86; }; node_88(){ optional 26; }
node_89(){ optional 27; }; node_90(){ required 52 46 47 25 88 89; }; node_91(){
required 52 46 59; }; node_92(){ required 52 46 25 36; }; node_93(){
required 52 46 25 48; }; node_94(){ required 52 46 25 49 60; }; node_95(){
required 52 50; }; node_96(){
either 57 61 63 64 65 69 71 72 73 74 78 79 81 82 85 87 90 91 92 93 94 95; }
node_97(){ required 96; }; cat <<<' docopt_exit() {
[[ -n $1 ]] && printf "%s\n" "$1" >&2; printf "%s\n" "${DOC:40:1116}" >&2
exit 1; }'; unset var___env var___help var___stack var___version var___server \
var___domain var___pass var___auto var___status var___skip_check var___force \
var___no_tty var___user var___all var__type_ var__app_ var__service_ var__src_ \
var__dst_ var__args_ var__secret_ var__version_ var__cmd_ var__data_ \
var__command_ var__host_ var__user_ var__port_ var_app var_new var_list var_ls \
var_deploy var_undeploy var_config var_delete var_rm var_logs var_cp var_check \
var_ps var_run var_secret var_auto var_generate var_insert var_server var_add \
var_init var_apps var_upgrade; parse 97 "$@"; local prefix=${DOCOPT_PREFIX:-''}
unset "${prefix}__env" "${prefix}__help" "${prefix}__stack" \
"${prefix}__version" "${prefix}__server" "${prefix}__domain" "${prefix}__pass" \
"${prefix}__auto" "${prefix}__status" "${prefix}__skip_check" \
"${prefix}__force" "${prefix}__no_tty" "${prefix}__user" "${prefix}__all" \
"${prefix}_type_" "${prefix}_app_" "${prefix}_service_" "${prefix}_src_" \
"${prefix}_dst_" "${prefix}_args_" "${prefix}_secret_" "${prefix}_version_" \
"${prefix}_cmd_" "${prefix}_data_" "${prefix}_command_" "${prefix}_host_" \
"${prefix}_user_" "${prefix}_port_" "${prefix}app" "${prefix}new" \
"${prefix}list" "${prefix}ls" "${prefix}deploy" "${prefix}undeploy" \
"${prefix}config" "${prefix}delete" "${prefix}rm" "${prefix}logs" \
"${prefix}cp" "${prefix}check" "${prefix}ps" "${prefix}run" "${prefix}secret" \
"${prefix}auto" "${prefix}generate" "${prefix}insert" "${prefix}server" \
"${prefix}add" "${prefix}init" "${prefix}apps" "${prefix}upgrade"
eval "${prefix}"'__env=${var___env:-}'
printf -- "exit %d\n" "$1"; exit "$1"; }; set -e; trimmed_doc=${DOC:1:1448}
usage=${DOC:40:1140}; digest=9b6cc
shorts=(-v -h -s -e '' '' '' '' '' '' '' '' '' '' '')
longs=(--version --help --stack --env --server --domain --app-name --pass --auto --status --skip-check --force --no-tty --user --all)
argcounts=(0 0 1 1 1 1 1 0 0 0 0 0 0 1 0); node_0(){ switch __version 0; }
node_1(){ switch __help 1; }; node_2(){ value __stack 2; }; node_3(){
value __env 3; }; node_4(){ value __server 4; }; node_5(){ value __domain 5; }
node_6(){ value __app_name 6; }; node_7(){ switch __pass 7; }; node_8(){
switch __auto 8; }; node_9(){ switch __status 9; }; node_10(){
switch __skip_check 10; }; node_11(){ switch __force 11; }; node_12(){
switch __no_tty 12; }; node_13(){ value __user 13; }; node_14(){ switch __all 14
}; node_15(){ value _type_ a; }; node_16(){ value _app_ a; }; node_17(){
value _service_ a; }; node_18(){ value _src_ a; }; node_19(){ value _dst_ a; }
node_20(){ value _args_ a true; }; node_21(){ value _secret_ a; }; node_22(){
value _version_ a; }; node_23(){ value _cmd_ a; }; node_24(){ value _data_ a; }
node_25(){ value _command_ a; }; node_26(){ value _host_ a; }; node_27(){
value _user_ a; }; node_28(){ value _port_ a; }; node_29(){ _command app; }
node_30(){ _command new; }; node_31(){ _command list; }; node_32(){ _command ls
}; node_33(){ _command deploy; }; node_34(){ _command undeploy; }; node_35(){
_command config; }; node_36(){ _command delete; }; node_37(){ _command rm; }
node_38(){ _command logs; }; node_39(){ _command cp; }; node_40(){
_command check; }; node_41(){ _command ps; }; node_42(){ _command run; }
node_43(){ _command secret; }; node_44(){ _command auto; }; node_45(){
_command generate; }; node_46(){ _command insert; }; node_47(){ _command server
}; node_48(){ _command add; }; node_49(){ _command init; }; node_50(){
_command apps; }; node_51(){ _command upgrade; }; node_52(){ optional 0 1 2 3; }
node_53(){ optional 52; }; node_54(){ optional 4; }; node_55(){ optional 5; }
node_56(){ optional 6; }; node_57(){ optional 7; }; node_58(){ optional 8; }
node_59(){ required 53 29 30 54 55 56 57 58 15; }; node_60(){ either 31 32; }
node_61(){ required 60; }; node_62(){ optional 9; }; node_63(){
required 53 29 61 62 54; }; node_64(){ optional 10; }; node_65(){
required 53 29 16 33 64; }; node_66(){ required 53 29 16 34; }; node_67(){
required 53 29 16 35; }; node_68(){ either 36 37; }; node_69(){ required 68; }
node_70(){ optional 11; }; node_71(){ required 53 29 16 69 70; }; node_72(){
optional 17; }; node_73(){ required 53 29 16 38 72; }; node_74(){
required 53 29 16 39 18 19; }; node_75(){ required 53 29 16 40; }; node_76(){
required 53 29 16 41; }; node_77(){ optional 12; }; node_78(){ optional 13; }
node_79(){ oneormore 20; }; node_80(){ required 53 29 16 42 77 78 17 79; }
node_81(){ required 53 29 16 43 44 57; }; node_82(){ optional 23; }; node_83(){
required 53 29 16 43 45 21 22 82 57; }; node_84(){
required 53 29 16 43 46 21 22 24 57; }; node_85(){ either 21 14; }; node_86(){
required 85; }; node_87(){ required 53 29 16 43 69 86 57 70; }; node_88(){
optional 79; }; node_89(){ required 53 29 16 25 88; }; node_90(){ optional 27; }
node_91(){ optional 28; }; node_92(){ required 53 47 48 26 90 91; }; node_93(){
required 53 47 61; }; node_94(){ required 53 47 26 37; }; node_95(){
required 53 47 26 49; }; node_96(){ required 53 47 26 50 62; }; node_97(){
required 53 51; }; node_98(){
either 59 63 65 66 67 71 73 74 75 76 80 81 83 84 87 89 92 93 94 95 96 97; }
node_99(){ required 98; }; cat <<<' docopt_exit() {
[[ -n $1 ]] && printf "%s\n" "$1" >&2; printf "%s\n" "${DOC:40:1140}" >&2
exit 1; }'; unset var___version var___help var___stack var___env var___server \
var___domain var___app_name var___pass var___auto var___status \
var___skip_check var___force var___no_tty var___user var___all var__type_ \
var__app_ var__service_ var__src_ var__dst_ var__args_ var__secret_ \
var__version_ var__cmd_ var__data_ var__command_ var__host_ var__user_ \
var__port_ var_app var_new var_list var_ls var_deploy var_undeploy var_config \
var_delete var_rm var_logs var_cp var_check var_ps var_run var_secret var_auto \
var_generate var_insert var_server var_add var_init var_apps var_upgrade
parse 99 "$@"; local prefix=${DOCOPT_PREFIX:-''}; unset "${prefix}__version" \
"${prefix}__help" "${prefix}__stack" "${prefix}__env" "${prefix}__server" \
"${prefix}__domain" "${prefix}__app_name" "${prefix}__pass" "${prefix}__auto" \
"${prefix}__status" "${prefix}__skip_check" "${prefix}__force" \
"${prefix}__no_tty" "${prefix}__user" "${prefix}__all" "${prefix}_type_" \
"${prefix}_app_" "${prefix}_service_" "${prefix}_src_" "${prefix}_dst_" \
"${prefix}_args_" "${prefix}_secret_" "${prefix}_version_" "${prefix}_cmd_" \
"${prefix}_data_" "${prefix}_command_" "${prefix}_host_" "${prefix}_user_" \
"${prefix}_port_" "${prefix}app" "${prefix}new" "${prefix}list" "${prefix}ls" \
"${prefix}deploy" "${prefix}undeploy" "${prefix}config" "${prefix}delete" \
"${prefix}rm" "${prefix}logs" "${prefix}cp" "${prefix}check" "${prefix}ps" \
"${prefix}run" "${prefix}secret" "${prefix}auto" "${prefix}generate" \
"${prefix}insert" "${prefix}server" "${prefix}add" "${prefix}init" \
"${prefix}apps" "${prefix}upgrade"
eval "${prefix}"'__version=${var___version:-false}'
eval "${prefix}"'__help=${var___help:-false}'
eval "${prefix}"'__stack=${var___stack:-}'
eval "${prefix}"'__version=${var___version:-false}'
eval "${prefix}"'__env=${var___env:-}'
eval "${prefix}"'__server=${var___server:-}'
eval "${prefix}"'__domain=${var___domain:-}'
eval "${prefix}"'__app_name=${var___app_name:-}'
eval "${prefix}"'__pass=${var___pass:-false}'
eval "${prefix}"'__auto=${var___auto:-false}'
eval "${prefix}"'__status=${var___status:-false}'
@ -258,19 +261,20 @@ eval "${prefix}"'init=${var_init:-false}'
eval "${prefix}"'apps=${var_apps:-false}'
eval "${prefix}"'upgrade=${var_upgrade:-false}'; local docopt_i=1
[[ $BASH_VERSION =~ ^4.3 ]] && docopt_i=2; for ((;docopt_i>0;docopt_i--)); do
declare -p "${prefix}__env" "${prefix}__help" "${prefix}__stack" \
"${prefix}__version" "${prefix}__server" "${prefix}__domain" "${prefix}__pass" \
"${prefix}__auto" "${prefix}__status" "${prefix}__skip_check" \
"${prefix}__force" "${prefix}__no_tty" "${prefix}__user" "${prefix}__all" \
"${prefix}_type_" "${prefix}_app_" "${prefix}_service_" "${prefix}_src_" \
"${prefix}_dst_" "${prefix}_args_" "${prefix}_secret_" "${prefix}_version_" \
"${prefix}_cmd_" "${prefix}_data_" "${prefix}_command_" "${prefix}_host_" \
"${prefix}_user_" "${prefix}_port_" "${prefix}app" "${prefix}new" \
"${prefix}list" "${prefix}ls" "${prefix}deploy" "${prefix}undeploy" \
"${prefix}config" "${prefix}delete" "${prefix}rm" "${prefix}logs" \
"${prefix}cp" "${prefix}check" "${prefix}ps" "${prefix}run" "${prefix}secret" \
"${prefix}auto" "${prefix}generate" "${prefix}insert" "${prefix}server" \
"${prefix}add" "${prefix}init" "${prefix}apps" "${prefix}upgrade"; done; }
declare -p "${prefix}__version" "${prefix}__help" "${prefix}__stack" \
"${prefix}__env" "${prefix}__server" "${prefix}__domain" "${prefix}__app_name" \
"${prefix}__pass" "${prefix}__auto" "${prefix}__status" \
"${prefix}__skip_check" "${prefix}__force" "${prefix}__no_tty" \
"${prefix}__user" "${prefix}__all" "${prefix}_type_" "${prefix}_app_" \
"${prefix}_service_" "${prefix}_src_" "${prefix}_dst_" "${prefix}_args_" \
"${prefix}_secret_" "${prefix}_version_" "${prefix}_cmd_" "${prefix}_data_" \
"${prefix}_command_" "${prefix}_host_" "${prefix}_user_" "${prefix}_port_" \
"${prefix}app" "${prefix}new" "${prefix}list" "${prefix}ls" "${prefix}deploy" \
"${prefix}undeploy" "${prefix}config" "${prefix}delete" "${prefix}rm" \
"${prefix}logs" "${prefix}cp" "${prefix}check" "${prefix}ps" "${prefix}run" \
"${prefix}secret" "${prefix}auto" "${prefix}generate" "${prefix}insert" \
"${prefix}server" "${prefix}add" "${prefix}init" "${prefix}apps" \
"${prefix}upgrade"; done; }
# docopt parser above, complete command for generating this parser is `docopt.sh abra`
PROGRAM_NAME=$(basename "$0")
@ -349,7 +353,7 @@ load_custom_commands() {
if [ -n "$abra__app_" ]; then
load_instance
load_instance_env
require_app_latest "$APP"
require_app_latest "$TYPE"
fi
if [ -f "$APP_DIR/abra-commands.sh" ]; then
@ -383,13 +387,13 @@ get_app_keys() {
}
load_instance() {
DOMAIN="$abra__app_"
APP="$abra__app_"
# FIXME 3wc: requires bash 4, use for loop instead
mapfile -t ENV_FILES < <(find -L "$ABRA_DIR" -name "$DOMAIN.env")
mapfile -t ENV_FILES < <(find -L "$ABRA_DIR" -name "$APP.env")
case "${#ENV_FILES[@]}" in
1 ) ;;
0 ) error "Can't find app '$DOMAIN'"; return;;
* ) error "Found $DOMAIN in multiple servers: ${ENV_FILES[*]}"; return;;
0 ) error "Can't find app '$APP'"; return;;
* ) error "Found $APP in multiple servers: ${ENV_FILES[*]}"; return;;
esac
ENV_FILE="${ENV_FILES[0]}"
if [ ! -f "$ENV_FILE" ]; then
@ -397,7 +401,7 @@ load_instance() {
fi
IFS='/' read -r -a PARTS <<< "$ENV_FILE"
SERVER="${PARTS[-2]}"
export STACK_NAME="${DOMAIN//./_}"
export STACK_NAME="$APP"
}
load_instance_env() {
@ -406,10 +410,10 @@ load_instance_env() {
source "$ENV_FILE"
set +a
if [ -z "$APP" ]; then
error "APP not set, maybe $ENV_FILE is using an old format?"
if [ -z "$TYPE" ]; then
error "TYPE not set, maybe $ENV_FILE is using an old format?"
fi
APP_DIR="$ABRA_DIR/apps/$APP"
APP_DIR="$ABRA_DIR/apps/$TYPE"
export DOCKER_CONTEXT="$SERVER"
export DOMAIN
}
@ -553,15 +557,16 @@ sub_app_new (){
# Note(decentral1se): we are overloading the use of the word "app" on this
# the interface and therefore try to use the word "type" to refer to "a type
# of app" vs. "an instance of an app"
APP=$abra__type_
TYPE=$abra__type_
SERVER=$abra___server
DOMAIN=$abra___domain
APP_NAME=$abra___app_name
require_app_latest "$APP"
require_app_latest "$TYPE"
if [ -z "$SERVER" ]; then
echo "Where would you like to put $APP?"
echo "Where would you like to put $TYPE?"
select SERVER_ITEM in "${SERVERS[@]##*/}"; do
if [ 1 -le "$REPLY" ] && [ "$REPLY" -le ${#SERVERS[@]} ]; then
@ -577,13 +582,21 @@ sub_app_new (){
error "Server '$SERVER' not found"
fi
APP_DIR="$ABRA_DIR/apps/$APP"
APP_DIR="$ABRA_DIR/apps/$TYPE"
if [ -z "$DOMAIN" ]; then
read -rp "Domain name: " DOMAIN
fi
ENV_FILE="$SERVER/$DOMAIN.env"
if [ -z "$APP_NAME" ]; then
DEFAULT_NAME="${TYPE/-/}_${DOMAIN//./_}"
read -rp "App name [$DEFAULT_NAME]: " APP_NAME
if [ -z "$APP_NAME" ]; then
APP_NAME="$DEFAULT_NAME"
fi
fi
ENV_FILE="$SERVER/$APP_NAME.env"
if [ -f "$ENV_FILE" ]; then
error "$ENV_FILE already exists"
@ -591,10 +604,10 @@ sub_app_new (){
fi
cp "$APP_DIR/.env.sample" "$ENV_FILE"
sed -i "s/$APP\.example\.com/$DOMAIN/g" "$ENV_FILE"
sed -i "s/$TYPE\.example\.com/$DOMAIN/g" "$ENV_FILE"
sed -i "s/example\.com/$DOMAIN/g" "$ENV_FILE"
abra__app_="$DOMAIN"
abra__app_="$APP_NAME"
get_app_secrets
@ -602,11 +615,11 @@ sub_app_new (){
sub_app_secret_auto
fi
echo "$(tput setaf 4)Your new '$APP' is ready for action:$(tput sgr0)"
echo "$(tput setaf 4)Your new '$TYPE' is ready for action:$(tput sgr0)"
echo " $(tput setaf 3)Customise the configuration:"
echo " abra app $DOMAIN config$(tput sgr0)"
echo " abra app $APP_NAME config$(tput sgr0)"
echo " $(tput setaf 2)Deploy it:"
echo " abra app $DOMAIN deploy$(tput sgr0)"
echo " abra app $APP_NAME deploy$(tput sgr0)"
}
###### .. app <domain> deploy
@ -614,7 +627,7 @@ sub_app_deploy (){
load_instance
load_instance_env
require_app_latest "$APP"
require_app_latest "$TYPE"
if [ "$abra___skip_check" == "false" ]; then
sub_app_check
@ -1020,7 +1033,8 @@ abra() {
abra__secret_ abra__version_ abra__data_ abra___user abra__host_ \
abra__type_ abra__port_ abra__user_ abra__service_ abra__src_ abra__dst_ \
abra__app_ abra___server abra___domain abra___force abra___pass \
abra___auto abra___status abra___no_tty abra___skip_check
abra___auto abra___status abra___no_tty abra___skip_check \
abra___app_name
if ! type tput > /dev/null 2>&1; then
tput() {